#!/bin/sh
# /////////////////////////////////////////////////////////////////////////////////////////////////
# NortonLifeLock copyright header start
# //////////////////////
#
# PROPRIETARY / CONFIDENTIAL.
# Use of this product is subject to license terms.
# Copyright (c) 2020 NortonLifeLock Inc.
# All rights reserved.
#
# /////////////////////////////////////////////////////////////////////////////////////////////////
# NortonLifeLock copyright header stop
# //////////////////////
#
#———————————————————————————————————————————————————————————————————————————————————————
  Version=2.0.1
# Copyright 2020 NortonLifeLock Inc. All rights reserved.
#
# Modified:     11/04/2020
#
# Usage:   See ShowHelp() function.
#
# Summary: See ShowHelp() function.
#
# History: 1.0.0 - Created.
#          1.0.1 - 07/19/2018 - Dylan Carlson:
#                  * Added deletion verification (MACSYS-3686).
#          1.0.2 - 01/09/2020 - Corey Swertfager:
#                  * Added copyright.
#          1.0.3 - 01/09/2020 - Dylan Carlson:
#                  * Updated files to remove
#          2.0.0 - 07/30/2020 - Corey Swertfager:
#                  * Revised script structure.
#                  * Added -c, -f, -L, and -l options.
#                  * Added deletion confirmation prompt.
#                  * Now also deletes symbolic links, as well as some bundles
#                    and enclosing folders.
#                  * Added some removals based on the Requirements.plist within
#                    Norton Security.SetupInstall.NS_ESD_8_0_MRF_19462_NS.zip
#                    from NS 8.5.8 build 40 (MACSYS-9215).
#          2.0.1 - 11/04/2020 - Corey Swertfager:
#                  * Added copyright section.

# *** Variable Initializations ***

PATH=/bin:/sbin:/usr/bin:/usr/sbin
LANG=""
PublicVersion=true
ShowQuitMessage=true

# ----- ProductFileList BEGIN ------------------------------------------------
#
# List each competitive product name, followed by files to remove for that
# product. File paths must all begin with /. Separate each product group with
# a blank line.
#
ProductFileList='
Avast Internet Security for Mac
/Applications/Avast.app/Contents/MacOS/Avast
/Applications/Avast.app
/Library/Application Support/Avast/components/chest/com.avast.chest
/Library/Application Support/Avast/components/fileshield/signed/AvastFileShield.kext
/Library/Application Support/Avast/config/com.avast.daemon.conf
/Library/Application Support/Avast

AVG Antivirus
/Applications/AVG AntiVirus.app/Contents/AvgOnAccess.kext
/Applications/AVG AntiVirus.app/Contents/Daemons/com.avg.Antivirus.infosd.plist
/Applications/AVG AntiVirus.app/Contents/Daemons/infosd
/Applications/AVG AntiVirus.app/Contents/MacOS/AVG AntiVirus
/Applications/AVG AntiVirus.app/Contents/PlugIns/Protection.bundle
/Applications/AVG AntiVirus.app
/Applications/AVGAntivirus.app/Contents/MacOS/AVGAntivirus
/Applications/AVGAntivirus.app
/Library/Application Support/AVGAntivirus/config/com.avg.daemon.conf
/Library/Application Support/AVGAntivirus

AVG Link Scanner
/Applications/AVG LinkScanner.app/Contents/MacOS/AVG LinkScanner
/Applications/AVG LinkScanner.app
/opt/avg/avg9/AvgNetShield.kext
/opt/avg/avg9/DaemonTools/com.avg.avgnotifyd.plist
/opt/avg

Avira Antivirus
/Applications/Avira.app/Contents/MacOS/Avira
/Applications/Avira.app
/Library/Application Support/Avira/first_installation
/Library/Application Support/Avira/Iris.app
/Library/Application Support/Avira/servicehubd.app
/Library/Application Support/Avira
/Library/LaunchDaemons/com.avira.antivirus.dbcleaner.plist
/Library/LaunchDaemons/com.avira.antivirus.ipm.loader.plist

Avira Security
/Applications/Avira Security.app/Contents/MacOS/Avira Security
/Applications/Avira Security.app

Bit Defender
/Library/Bitdefender/AVP/antiphishing.bundle
/Library/Bitdefender/AVP/antivirus.bundle
/Library/Bitdefender/AVP/common.bundle
/Library/Bitdefender

Eset Cyber Security
/Applications/.esets/Contents/MacOS/esets_ctl
/Applications/ESET Cyber Security.app/Contents/MacOS/esets_daemon
/Applications/ESET Cyber Security.app
/Library/Application Support/ESET/esets/etc/info/pkgid2
/Library/Application Support/ESET
/Library/LaunchDaemons/com.eset.esets_daemon.plist

Eset Cyber Security Pro
/Applications/ESET Cyber Security Pro.app/Contents/MacOS/esets_daemon
/Applications/ESET Cyber Security Pro.app
/Library/Application Support/ESET/esets/etc/info/pkgid2
/Library/Application Support/ESET

F-Secure Antivirus
/Applications/F-Secure/F-Secure Mac Protection.app/Contents/MacOS/F-Secure Mac Protection
/Applications/F-Secure
/Library/Application Support/F-Secure/expirytime
/Library/Application Support/F-Secure
/Library/LaunchAgents/com.f-secure.fsmac.gui.plist
/Library/LaunchDaemons/com.f-secure.fsavd.plist

Intego Internet Security
/Applications/Intego/NetBarrier.app/Contents/MacOS/NetBarrier
/Applications/Intego
/Library/Application Support/Intego/Extensions/NetBarrierMonitor.kext
/Library/Application Support/Intego/Extensions/NetBarrierNetwork.kext
/Library/Application Support/Intego/Extensions/NetBarrierProcess.kext
/Library/Application Support/Intego
/Library/Intego/netbarrier.bundle
/Library/Intego/netbarrierd.bundle
/Library/Intego/personalantispamd.bundle
/Library/Intego/personalbackupd.bundle
/Library/Intego
/Library/LaunchDaemons/com.intego.netbarrier.daemon.plist

Intego VirusBarrier
/Applications/Intego/VirusBarrier.app/Contents/MacOS/VirusBarrier
/Applications/Intego
/Library/Intego/virusbarrier.bundle
/Library/Intego
/Library/LaunchDaemons/com.intego.virusbarrier.daemon.plist

Kaspersky Internet Security
/Applications/Kaspersky Anti-Virus For Mac.app/Contents/Resources/CloudLicensesView.nib
/Applications/Kaspersky Anti-Virus For Mac.app
/Library/Application Support/Kaspersky Lab/KAV/Binaries/kav
/Library/Application Support/Kaspersky Lab
/Library/LaunchAgents/com.kaspersky.kav.gui.plist
/Library/LaunchDaemons/com.kaspersky.gui.plist
/Library/LaunchDaemons/com.kaspersky.kav.plist
/Library/Services/KAVService.service/Contents/MacOS/kavservice
/Library/Services/KAVService.service

Little Snitch
/Library/Little Snitch/Little Snitch Agent.app/Contents/MacOS/Little Snitch Agent
/Library/Little Snitch/Little Snitch Daemon.bundle/Contents/MacOS/Little Snitch Daemon
/Library/Little Snitch

McAfee Family Protection
/Applications/McAfee Family Protection.app/Contents/MacOS/McAfee Family Protection
/Applications/McAfee Family Protection.app
/Library/LaunchDaemons/com.McAfee.Startup.plist
/usr/local/familyProtection/var/tmp/familyProtection
/usr/local/familyProtection

McAfee Internet Security
/Library/LaunchDaemons/com.mcafee.cspd.plist
/Library/LaunchDaemons/com.mcafee.ssm.ScanManager.plist
/usr/local/McAfee/AntiMalware/VShieldScanner
/usr/local/McAfee/Firewall/bin/FWService
/usr/local/McAfee/fmp/lib/libmoniterservice.dylib
/usr/local/McAfee/SAFM/bin/SiteAdvisorFM
/usr/local/McAfee/SiteAdvisor/bin/UninstallSA.sh
/usr/local/McAfee

McAfee Virex
/Library/LaunchDaemons/com.mcafee.virusscan.ScanManager.plist
/usr/local/vscanx/VirexLogin.app
/usr/local/vscanx/VShieldMount
/usr/local/vscanx/VShieldScheduleHelper
/usr/local/vscanx

Sophos Antivirus
/Applications/Sophos Anti-Virus.app/Contents/MacOS/Sophos Anti-Virus
/Applications/Sophos Anti-Virus.app
/Library/Application Support/Sophos/he/Sophos Installer Components/savi.bundle
/Library/Application Support/Sophos
/Library/LaunchDaemons/com.sophos.common.servicemanager.plist

Sophos Home
/Applications/Sophos Home.app/Contents/MacOS/Sophos Home
/Applications/Sophos Home.app
/Library/Application Support/Sophos/che/Sophos Installer Components/av-home.bundle
/Library/Application Support/Sophos/che/Sophos Installer Components/savi.bundle
/Library/Application Support/Sophos

Trend Micro Internet Security
/Library/Application Support/TrendMicro/common/conf/tmccmac.conf.plist
/Library/Application Support/TrendMicro/common/conf/TmDb.conf.plist
/Library/Application Support/TrendMicro/common/conf/TmUpdate.conf.plist
/Library/Application Support/TrendMicro/common/lib/libtaskManager.dylib
/Library/Application Support/TrendMicro/common/lib/libTmccCoreCommon.dylib
/Library/Application Support/TrendMicro/common/lib/RCM/iTMKernAPIWrapper.dylib
/Library/Application Support/TrendMicro/TmccMac/iCoreMgr
/Library/Application Support/TrendMicro
/Library/LaunchDaemons/com.trendmicro.icore.av.plist
/Library/LaunchDaemons/com.trendmicro.itis.plugin.plist

Trend Micro Smart Surfing
/Applications/TrendMicro.localized/iTIS.app/Contents/MacOS/iTIS
/Applications/TrendMicro.localized
/Library/Application Support/TrendMicro/common/lib/libTmccCoreUpdate.dylib
/Library/Application Support/TrendMicro/Plug-in/iTISPlugin.plist
/Library/Application Support/TrendMicro

Webroot Security
/Library/LaunchDaemons/com.webroot.security.mac.plist
/usr/local/bin/WSDaemon
'
# ----- ProductFileList END --------------------------------------------------

# ----- ItemsRemovedByVersion103 BEGIN ------------------------------------------------
#
# NOTE: RemoveCompetitiveProducts.command 1.0.3 had erroneously left off leading / from:
#       Library/Application Support/ESET/esets/etc/info/pkgid2
#
ItemsRemovedByVersion103='
/Applications/.esets/Contents/MacOS/esets_ctl
/Applications/Avast.app/Contents/MacOS/Avast
/Applications/AVG AntiVirus.app/Contents/AvgOnAccess.kext
/Applications/AVG AntiVirus.app/Contents/Daemons/com.avg.Antivirus.infosd.plist
/Applications/AVG AntiVirus.app/Contents/Daemons/infosd
/Applications/AVG AntiVirus.app/Contents/MacOS/AVG AntiVirus
/Applications/AVG AntiVirus.app/Contents/PlugIns/Protection.bundle
/Applications/AVG LinkScanner.app/Contents/MacOS/AVG LinkScanner
/Applications/AVGAntivirus.app/Contents/MacOS/AVGAntivirus
/Applications/Avira.app/Contents/MacOS/Avira
/Applications/ESET Cyber Security.app/Contents/MacOS/esets_daemon
/Applications/F-Secure/F-Secure Mac Protection.app/Contents/MacOS/F-Secure Mac Protection
/Applications/Intego/NetBarrier.app/Contents/MacOS/NetBarrier
/Applications/Intego/VirusBarrier.app/Contents/MacOS/VirusBarrier
/Applications/Kaspersky Anti-Virus For Mac.app/
/Applications/McAfee Family Protection.app/Contents/MacOS/McAfee Family Protection
/Applications/Sophos Anti-Virus.app/Contents/MacOS/Sophos Anti-Virus
/Applications/TrendMicro.localized/iTIS.app/Contents/MacOS/iTIS
/Library/Application Support/Avast/components/chest/com.avast.chest
/Library/Application Support/Avast/components/fileshield/signed/AvastFileShield.kext
/Library/Application Support/Avast/config/com.avast.daemon.conf
/Library/Application Support/AVGAntivirus/config/com.avg.daemon.conf
/Library/Application Support/Avira/first_installation
/Library/Application Support/Avira/Iris.app
/Library/Application Support/Avira/servicehubd.app
Library/Application Support/ESET/esets/etc/info/pkgid2
/Library/Application Support/F-Secure/expirytime
/Library/Application Support/Intego/Extensions/NetBarrierMonitor.kext
/Library/Application Support/Intego/Extensions/NetBarrierNetwork.kext
/Library/Application Support/Intego/Extensions/NetBarrierProcess.kext
/Library/Application Support/Kaspersky Lab/KAV/Binaries/kav
/Library/Application Support/Sophos/he/Sophos Installer Components/savi.bundle
/Library/Application Support/TrendMicro/common/conf/tmccmac.conf.plist
/Library/Application Support/TrendMicro/common/conf/TmDb.conf.plist
/Library/Application Support/TrendMicro/common/conf/TmUpdate.conf.plist
/Library/Application Support/TrendMicro/common/lib/libtaskManager.dylib
/Library/Application Support/TrendMicro/common/lib/libTmccCoreCommon.dylib
/Library/Application Support/TrendMicro/common/lib/libTmccCoreUpdate.dylib
/Library/Application Support/TrendMicro/common/lib/RCM/iTMKernAPIWrapper.dylib
/Library/Application Support/TrendMicro/TmccMac/iCoreMgr
/Library/Bitdefender/AVP/antiphishing.bundle
/Library/Bitdefender/AVP/antivirus.bundle
/Library/Bitdefender/AVP/common.bundle
/Library/Intego/netbarrier.bundle
/Library/Intego/netbarrierd.bundle
/Library/Intego/personalantispamd.bundle
/Library/Intego/personalbackupd.bundle
/Library/Intego/virusbarrier.bundle
/Library/LaunchAgents/com.kaspersky.kav.gui.plist
/Library/LaunchDaemons/com.avira.antivirus.dbcleaner.plist
/Library/LaunchDaemons/com.avira.antivirus.ipm.loader.plist
/Library/LaunchDaemons/com.eset.esets_daemon.plist
/Library/LaunchDaemons/com.f-secure.fsavd.plist
/Library/LaunchDaemons/com.intego.netbarrier.daemon.plist
/Library/LaunchDaemons/com.intego.virusbarrier.daemon.plist
/Library/LaunchDaemons/com.kaspersky.gui.plist
/Library/LaunchDaemons/com.kaspersky.kav.plist
/Library/LaunchDaemons/com.mcafee.cspd.plist
/Library/LaunchDaemons/com.mcafee.ssm.ScanManager.plist
/Library/LaunchDaemons/com.McAfee.Startup.plist
/Library/LaunchDaemons/com.mcafee.virusscan.ScanManager.plist
/Library/LaunchDaemons/com.sophos.common.servicemanager.plist
/Library/LaunchDaemons/com.trendmicro.icore.av.plist
/Library/LaunchDaemons/com.trendmicro.itis.plugin.plist
/Library/LaunchDaemons/com.webroot.security.mac.plist
/Library/Little Snitch/Little Snitch Agent.app/Contents/MacOS/Little Snitch Agent
/Library/Little Snitch/Little Snitch Daemon.bundle/Contents/MacOS/Little Snitch Daemon
/Library/Services/KAVService.service
/opt/avg/avg9/AvgNetShield.kext
/opt/avg/avg9/DaemonTools/com.avg.avgnotifyd.plist
/usr/local/bin/WSDaemon
/usr/local/familyProtection/var/tmp/familyProtection
/usr/local/McAfee/AntiMalware/VShieldScanner
/usr/local/McAfee/Firewall/bin/FWService
/usr/local/McAfee/fmp/lib/libmoniterservice.dylib
/usr/local/McAfee/SAFM/bin/SiteAdvisorFM
/usr/local/McAfee/SiteAdvisor/bin/UninstallSA.sh
/usr/local/vscanx/VirexLogin.app
/usr/local/vscanx/VShieldMount
/usr/local/vscanx/VShieldScheduleHelper
'
# ----- ItemsRemovedByVersion103 END --------------------------------------------------

# ----- ItemsAddedForVersion200 BEGIN ------------------------------------------------
ItemsAddedForVersion200='
Avira Security
/Applications/Avira Security.app/Contents/MacOS/Avira Security

Eset Cyber Security Pro
/Applications/ESET Cyber Security Pro.app/Contents/MacOS/esets_daemon

F-Secure
/Library/LaunchAgents/com.f-secure.fsmac.gui.plist

Kaspersky Internet Security
/Library/Services/KAVService.service/Contents/MacOS/kavservice

Kaspersky Security Cloud
/Applications/Kaspersky Anti-Virus For Mac.app/Contents/Resources/CloudLicensesView.nib
/Library/Services/KAVService.service/Contents/MacOS/kavservice

Sophos Home
/Applications/Sophos Home.app/Contents/MacOS/Sophos Home
/Library/Application Support/Sophos/che/Sophos Installer Components/av-home.bundle
/Library/Application Support/Sophos/che/Sophos Installer Components/savi.bundle

Trend Micro Smart Surfing
/Library/Application Support/TrendMicro/Plug-in/iTISPlugin.plist
'
# ----- ItemsAddedForVersion200 END --------------------------------------------------

# *** Function Declarations ***

ExitScript()
{
   # Usage:     ExitScript [-b] [-e] [exit_number [error_string]]
   # Summary:   Checks to see if ShowQuitMessage and RunScriptAsStandAlone
   #            variables are set to true. If so, a message is displayed;
   #            otherwise, no message is displayed. The script is then
   #            exited and passes exit_number to exit command. If no
   #            exit_number is passed, then 0 is passed to exit command. If
   #            a non-integer is passed as exit_number, 255 is passed to
   #            exit command. If error_string is passed, it is printed to
   #            to standard out before exiting and is padded by blank lines 
   #            if error_string is not "". Pass -b before exit_number to
   #            suppress beginning padding line, -e to suppress ending
   #            padding line, both to suppress both.
   #
   local PadBeginning=true
   local PadEnd=true
   while [ "$1" ] ; do
      case "$1" in
         -b)
            PadBeginning=false
            ;;
         -e)
            PadEnd=false
            ;;
         *)
            break
            ;;
      esac
      shift
   done
   if [ $# -gt 1 ] ; then
      if [ -z "$2" ] ; then
         PadBeginning=false
         PadEnd=false
      fi
      $PadBeginning && echo 
      printf "%s\n" "$2"
      $PadEnd && echo
   fi
   if [ "z$ShowQuitMessage" = ztrue -a "z$RunScriptAsStandAlone" = ztrue ] ; then
      [ $# -lt 2 -o \( $PadEnd = false -a -n "$2" \) ] && echo
      echo "NOTE: If you double-clicked this program, quit Terminal application now."
      [ $PadEnd = true -o -z "$2" ] && echo
   fi
   [ -z "$1" ] && exit 0
   [ -z "`expr "$1" / 1 2>/dev/null`" ] && exit 255 || exit $1
}

GetAdminPassword()
{
   # Usage:     GetAdminPassword [$1]
   # Argument:  $1 - Prompt for password. If true is passed, a user that
   #                 is not root will always be asked for a password. If
   #                 something other than true is passed or if nothing is
   #                 passed, then a user that is not root will only be
   #                 prompted for a password if authentication has lapsed.
   # Summary:   Gets an admin user password from the user so that
   #            future sudo commands can be run without a password
   #            prompt. The script is exited with a value of 1 if
   #            the user enters an invalid password or if the user
   #            is not an admin user. If the user is the root user,
   #            then there is no prompt for a password (there is
   #            no need for a password when user is root).
   #            NOTE: Make sure ExitScript function is in the script.
   #
   # If root user, no need to prompt for password
   [ "`whoami`" = "root" ] && return 0
   echo
   # If prompt for password
   if [ "$1" = "true" ] ; then
      sudo -k   # Make sudo require a password the next time it is run
      echo "You must be an admin user to run this program."
   fi
   # A dummy sudo command to get password
   sudo -p "Please enter your admin password: " date 2>/dev/null 1>&2
   if [ ! $? = 0 ] ; then       # If failed to get password, alert user and exit script
      echo "You entered an invalid password or you are not an admin user. Program aborted."
      ExitScript 1
   fi
}

ProcessArguments()
{
   # Usage:     ProcessArguments [ --OptionTakesUnparsedArgument=string ] [ --OptionIsOneArgument=string ] "$@"
   #
   # Version:   1.0.1
   #
   # Summary:   Processes arguments passed to script. Arguments beginning with a
   #            single hyphen (-) are parsed into separate options except when an
   #            argument is negative integer. Arguments beginning with two hypens
   #            are treated as one argument; if the argument contains is an equals
   #            sign (=), the string after the first "=" is treated as a separate
   #            argument (i.e., the value assigned to the double-hyphen argument).
   #
   #            For each --OptionTakesUnparsedArgument passed before "$@", the string
   #            after "=" is used as an option that takes the next argument in full
   #            without parsing it (see examples below); string must be a hyphen
   #            followed by a single character.
   #
   #            For each --OptionIsOneArgument passed before "$@", the string after
   #            "=" is used as an option that should be treated as a single argument.
   #            This is useful when processing an argument that begins with a single
   #            hyphen to avoid having that argument parsed into separate options.
   #            The referenced option cannot be embedded within other options (see
   #            final example below).
   #
   #            "$@" must be the last argument passed to ProcessArguments. Put all custom
   #            option handling between "--- Customized argument handling begins here ---"
   #            and "--- Customized argument handling ends here ---".
   #
   # Note:      ProcessArgumentsNextArgument may be called to verify and obtain the
   #            next argument after or before a given option; see that function's usage
   #            for more details. OriginalArgumentNumber can be used to determine if
   #            two arguments were originally passed within the same string of options.
   #
   # Examples:  These examples have expanded the arguments passed as "$@".
   #
   #            ProcessArguments -ab -c
   #               Would process three arguments: -a, -b, and -c
   #            ProcessArguments --ab -c
   #               Would process two arguments: --ab and -c
   #            ProcessArguments --equation=a=b+c
   #               Would process two arguments: --equation and a=b+c
   #            ProcessArguments -10
   #               Would process one argument: -10
   #            ProcessArguments -10a
   #               Would process three arguments: -1, -0, -a
   #            ProcessArguments --OptionTakesUnparsedArgument=-e -e -ger
   #               Would process two arguments: -e and -ger
   #            ProcessArguments --OptionTakesUnparsedArgument=-e -peer
   #               Would process three arguments: -p, -e, and er
   #            ProcessArguments --OptionTakesUnparsedArgument=-e --OptionTakesUnparsedArgument=-t -eter -ter
   #               Would process four arguments: -e, ter, -t, and er
   #            ProcessArguments --OptionIsOneArgument=-hi -hi
   #               Would process one argument: -hi
   #            ProcessArguments --OptionIsOneArgument=-hi -his
   #               Would process three arguments: -h, -i, and -s
   #
   # History: 1.0.1 - 06/23/2013 - Corey Swertfager:
   #                  * Added processing of options within a string that begins
   #                    with a single hyphen.
   #                  * Added --OptionTakesUnparsedArgument option.
   #                  * Added --OptionIsOneArgument option.
   #
   local ArgList=""
   local ArgsToAdd
   local ArgWasAdded=false
   local CurrentArgNumber=1
   local CurrentArgument
   local CurrentCharacter
   local DoNotParseNextArgument=false
   local NextArgument=""
   local NumberOfArgumentsPassed
   local NumberOfArgumentsToUse=0
   local OptionToAdd
   local OriginalArgumentNumber=0
   local OriginalArgumentNumberList=""
   local RemainingOptionsInString
   local TableOfOptionsWithoutParsing="*** Each option in this table will have its succeeding argument left unparsed. ***"
   local TableOfUndividedArguments="*** Each item in this table should each be treated as single argument. ***"
   while [ "$1" ] ; do
      case "$1" in
         --OptionIsOneArgument)
            ExitScript 99 "WARNING: Bad use of --OptionIsOneArgument passed to ProcessArguments:
         \"$1\""
            ;;
         --OptionIsOneArgument=*)
            OptionToAdd=`printf "%s" "$1" | awk '{match($0,"=") ; print substr($0,RSTART+1)}'`
            [ -z "$OptionToAdd" ] && ExitScript 99 "WARNING: Bad use of --OptionIsOneArgument passed to ProcessArguments:
         \"$1\""
            TableOfUndividedArguments="$TableOfUndividedArguments
$OptionToAdd"
            ;;
         --OptionTakesUnparsedArgument|--OptionTakesUnparsedArgument=*)
            OptionToAdd=`printf "%s" "$1" | awk '{match($0,"=") ; print substr($0,RSTART+1)}'`
            [ -z "`printf "%s" "$OptionToAdd" | grep -xe '-.'`" ] && ExitScript 99 "WARNING: Bad use of --OptionTakesUnparsedArgument passed to ProcessArguments:
         \"$1\""
            TableOfOptionsWithoutParsing="$TableOfOptionsWithoutParsing
$OptionToAdd"
            ;;
         *)
            break
            ;;
      esac
      shift
   done
   NumberOfArgumentsPassed=$#
   while [ $# != 0 ] ; do
      let OriginalArgumentNumber=$OriginalArgumentNumber+1
      # If argument is in the list of arguments whose next argument should not be parsed
      if [ "`printf "%s" "$1" | grep -xF "$TableOfOptionsWithoutParsing"`" ] ; then
         ArgsToAdd="$1"
         OriginalArgumentNumberList="$OriginalArgumentNumberList
$OriginalArgumentNumber"
         DoNotParseNextArgument=true
      # Else if argument is in the list of arguments that should be treated as one argument
      elif [ "`printf "%s" "$1" | grep -xF "$TableOfUndividedArguments"`" ] ; then
         ArgsToAdd="$1"
         OriginalArgumentNumberList="$OriginalArgumentNumberList
$OriginalArgumentNumber"
      else
         case "$1" in
            -|-?)
               # If argument was a hyphen or a hyphen followed by a single character
               ArgsToAdd="$1"
               OriginalArgumentNumberList="$OriginalArgumentNumberList
$OriginalArgumentNumber"
               DoNotParseNextArgument=false
               ;;
            --*)
               # If a value was passed to the option that begins with --
               if [ "`printf "%s" "$1" | grep =`" ] ; then
                  # Add the option and its value as separate arguments
                  ArgsToAdd="`printf "%s" "$1" | awk -F = '{print $1}'`
`printf "%s" "$1" | awk '{match($0,"=") ; print substr($0,RSTART+1)}'`"
                  OriginalArgumentNumberList="$OriginalArgumentNumberList
$OriginalArgumentNumber
$OriginalArgumentNumber"
               else
                  ArgsToAdd="$1"
                  OriginalArgumentNumberList="$OriginalArgumentNumberList
$OriginalArgumentNumber"
               fi
               DoNotParseNextArgument=false
               ;;
            -*)
               # If argument should not be parsed or is a negative integer
               if [ $DoNotParseNextArgument = true -o -z "`printf "%s" "$1" | awk '{print substr($0,2)}' | tr -d '[:digit:]'`" ] ; then
                  # Treat argument as a single argument
                  ArgsToAdd="$1"
                  OriginalArgumentNumberList="$OriginalArgumentNumberList
$OriginalArgumentNumber"
                  DoNotParseNextArgument=false
               else
                  # Parse string into separate arguments
                  ArgsToAdd=""
                  RemainingOptionsInString=`printf "%s" "$1" | awk '{print substr($0,2)}'`
                  while [ "$RemainingOptionsInString" ] ; do
                     CurrentCharacter=`printf "%s" "$RemainingOptionsInString" | awk '{print substr($0,1,1)}'`
                     # Prefix the character with a hyphen and add as an argument
                     if [ "$ArgsToAdd" ] ; then
                        ArgsToAdd="$ArgsToAdd
-$CurrentCharacter"
                     else
                        ArgsToAdd="-$CurrentCharacter"
                     fi
                     OriginalArgumentNumberList="$OriginalArgumentNumberList
$OriginalArgumentNumber"
                     RemainingOptionsInString=`printf "%s" "$RemainingOptionsInString" | awk '{print substr($0,2)}'`
                     # If this is an option whose next string should not be parsed
                     if [ "`printf "%s" "$TableOfOptionsWithoutParsing" | grep -xe "-$CurrentCharacter"`" ] ; then
                        # If string has characters remaining after that option
                        if [ "$RemainingOptionsInString" ] ; then
                           # Add remainder of string as the unparsed string argument
                           ArgsToAdd="$ArgsToAdd
$RemainingOptionsInString"
                           OriginalArgumentNumberList="$OriginalArgumentNumberList
$OriginalArgumentNumber"
                        else
                           # Use next argument passed as unparsed string argument
                           DoNotParseNextArgument=true
                        fi
                        break
                     fi
                  done
               fi
               ;;
            *)
               ArgsToAdd="$1"
               OriginalArgumentNumberList="$OriginalArgumentNumberList
$OriginalArgumentNumber"
               DoNotParseNextArgument=false
               ;;
         esac
      fi
      if $ArgWasAdded ; then
         ArgList="$ArgList
$ArgsToAdd"
      else
         ArgList="$ArgsToAdd"
      fi
      ArgWasAdded=true
      shift
   done
   if [ $NumberOfArgumentsPassed -gt 0 ] ; then
      # Add a non-blank line to ArgList in case last argument passed was ""
      ArgList="$ArgList
           TheEnd"
      OriginalArgumentNumberList=`echo "$OriginalArgumentNumberList" | grep .`
      NumberOfArgumentsToUse=`printf "%s" "$ArgList" | grep "" -c`
      let NumberOfArgumentsToUse=$NumberOfArgumentsToUse-1
   fi
   # --- Customized argument handling begins here ---
   DoForceUninstall=false
   DoShowFilesInstalled=false
   DoShowSearchList=false
   while [ $CurrentArgNumber -le $NumberOfArgumentsToUse ] ; do
      CurrentArgument=`printf "%s" "$ArgList" | head -n $CurrentArgNumber | tail -n 1`
      OriginalArgumentNumber=`echo "$OriginalArgumentNumberList" | head -n $CurrentArgNumber | tail -n 1`
      case "$CurrentArgument" in
         -c)
            :
            ;;
         -f)
            DoForceUninstall=true
            DoShowFilesInstalled=false
            DoShowSearchList=false
            ;;
         -H)
            ShowUsage 0
            ;;
         -h)
            ShowHelp 0
            ;;
         -L)
            DoForceUninstall=false
            DoShowFilesInstalled=false
            DoShowSearchList=true
            ;;
         -l)
            DoForceUninstall=false
            DoShowFilesInstalled=true
            DoShowSearchList=false
            ;;
         -V)
            echo $Version
            exit 0
            ;;
         *)
            ShowUsage 2 "ERROR: Invalid option: \"$CurrentArgument\""
            ;;
      esac
      let CurrentArgNumber=$CurrentArgNumber+1
   done
   # --- Customized argument handling ends here ---
}

ProcessArgumentsNextArgument()
{
   # Usage:     ProcessArgumentsNextArgument [exit_code] [-F | -P] [-p | -r ] [operator]
   #
   # Version:   1.0.0
   #
   # Arguments: exit_code   Pass integer in range 0-255 to ShowUsage when next
   #                        argument is missing or invalid. If exit_code is not
   #                        specified, 0 is assumed.
   #
   #            -F          Assign the full logical path to NextArgumentFullPath.
   #                        This is the default. ShowFullFilePath function must
   #                        be included in script. If no operator was passed, -E
   #                        is the assumed operator.
   #
   #            -P          Assign the full physical path to NextArgumentFullPath.
   #                        ShowFullFilePath function must be included in script.
   #                        If no operator was passed, -e is the assumed operator.
   #
   #            -p          Get previous argument instead of next argument. If
   #                        there is no previous argument, sets NextArgument to ""
   #                        and returns 1.
   #
   #            -r          Return 1 instead of exiting script if there is no next
   #                        argument. Sets NextArgument to "".
   #
   #            operator    Operator used to test next argument:
   #                           -d   Folder
   #                           -E   File, folder, or link
   #                           -e   File, folder, or link to an existing file/folder
   #                           -f   File
   #                           -i [min [max]]
   #                                Integer in range min-max; pass "" to min and
   #                                an integer to max if there is no minimum but
   #                                a maximum is desired; pass "" to to both min
   #                                and max if passing another option after the -i
   #                                option. Also tests to see if the value of the
   #                                next argument is out of range for the currently
   #                                running version of Mac OS.
   #                           -L   Link; does not check to see if link is broken
   #                                unless -P option was also passed
   #                           -l   Link to an existing file/folder
   #                           -n   Non-null string
   #
   # Summary:   Called by ProcessArguments 1.0.1 or later to assign values to:
   #
   #               CurrentArgNumber
   #               NextArgument
   #               NextArgumentFullPath
   #               NextArgumentOriginalArgumentNumber
   #
   #            using pre-existing values of:
   #
   #               ArgList
   #               CurrentArgNumber
   #               CurrentArgument
   #               OriginalArgumentNumberList
   #               NumberOfArgumentsToUse
   #
   #            Returns 0 if next or previous argument was assigned to NextArgument,
   #            CurrentArgNumber was incremented (or decremented if -p was passed),
   #            and NextArgumentOriginalArgumentNumber was assigned.
   #
   #            Assigns "" to NextArgument and NextArgumentFullPath and returns 1 if
   #            -p is passed and there is no previous argument, or if -r is passed
   #            and there is no next argument; otherwise, calls ShowUsage to show
   #            error message and exit script if operator test fails or if there is
   #            no next or previous argument.
   #
   # Note:      ShowFullFilePath function must be included in script in order to
   #            assign a value to NextArgumentFullPath.
   #
   # Examples:  ProcessArgumentsNextArgument
   #               Returns 0 if there was a next argument; otherwise, passes 0 to
   #               ShowUsage and displays error message about missing argument.
   #            ProcessArgumentsNextArgument -r
   #               Returns 0 if there was a next argument; otherwise, assigns "" to
   #               NextArgument and NextArgumentFullPath, then returns 1.
   #            ProcessArgumentsNextArgument 2 -d
   #               Returns 0 if NextArgument was set to a folder; otherwise, passes
   #               2 to ShowUsage and displays error message if the next argument is
   #               missing or is not a folder.
   #            ProcessArgumentsNextArgument 3 -r -d
   #               Returns 0 if NextArgument was set to a folder. If the next argument
   #               is missing, assigns "" to NextArgument and NextArgumentFullPath,
   #               then returns 1. If next argument is not a folder, passes 3 to
   #               ShowUsage and displays error message.
   #            ProcessArgumentsNextArgument 4 -i 1
   #               Returns 0 if NextArgument was set to an integer; otherwise, passes
   #               4 to ShowUsage and displays error message if the next argument is
   #               missing, is not an integer, or is less than 1.
   #            ProcessArgumentsNextArgument -i "" 100 5
   #               Returns 0 if NextArgument was set to an integer; otherwise, passes
   #               5 to ShowUsage and displays error message if the next argument is
   #               missing, is not an integer, or is greater than 100.
   #            ProcessArgumentsNextArgument -i "" "" 6
   #               Returns 0 if NextArgument was set to an integer; otherwise, passes
   #               6 to ShowUsage and displays error message if the next argument is
   #               missing or is not an integer.
   #
   local DoShowMissingError=true
   local DirectionText=after
   local ExitCode=0
   local ErrorText=""
   local GoToPreviousArgument=false
   local Max
   local Min
   local NextArgumentOriginal
   local PathOption=""
   local TestOperator=""
   NextArgumentFullPath=""
   while [ "$1" ] ; do
      case "$1" in
         -d)
            ErrorText="folder"
            TestOperator="$1"
            ;;
         -E)
            ErrorText="file, folder, or link"
            TestOperator="$1"
            ;;
         -e)
            ErrorText="file or folder"
            TestOperator="$1"
            ;;
         -F)
            PathOption="$1"
            if [ -z "$ErrorText" ] ; then
               ErrorText="file, folder, or link"
               TestOperator="-E"
            fi
            ;;
         -f)
            ErrorText="file"
            TestOperator="$1"
            ;;
         -i)
            ErrorText="integer"
            TestOperator="$1"
            Min="$2"
            Max="$3"
            shift 2
            ;;
         -L)
            ErrorText="link"
            TestOperator="$1"
            [ "z$PathOption" = "z-P" ] && ErrorText="unbroken link"
            ;;
         -l)
            ErrorText="unbroken link"
            TestOperator="-L"
            ;;
         -n)
            ErrorText="non-null string"
            TestOperator="$1"
            ;;
         -P)
            PathOption="$1"
            if [ -z "$ErrorText" ] ; then
               ErrorText="file or folder"
               TestOperator="-e"
            elif [ "$ErrorText" = "link" ] ; then
               ErrorText="unbroken link"
            fi
            ;;
         -p)
            GoToPreviousArgument=true
            DirectionText=before
            ;;
         -r)
            DoShowMissingError=false
            ;;
         *)
            ExitCode=`printf "%s" "$1" | tr -d -c "[:digit:]"`
            [ -z "$ExitCode" ] && ExitCode=0
            ;;
      esac
      shift
   done
   if $GoToPreviousArgument ; then
      if [ $CurrentArgNumber -gt 1 ] ; then
         let CurrentArgNumber=$CurrentArgNumber-1
         NextArgument=`printf "%s" "$ArgList" | head -n $CurrentArgNumber | tail -n 1`
         NextArgumentOriginalArgumentNumber=`echo "$OriginalArgumentNumberList" | head -n $CurrentArgNumber | tail -n 1`
      else
         NextArgument=""
         NextArgumentFullPath=""
         return 1
      fi
   # Else if there are no more arguments in ArgList
   elif [ $CurrentArgNumber = $NumberOfArgumentsToUse ] ; then
      if $DoShowMissingError ; then
         ShowUsage $ExitCode "ERROR: Nothing was passed after $CurrentArgument" >&2
      else
         NextArgument=""
         NextArgumentFullPath=""
         return 1
      fi
   else
      let CurrentArgNumber=$CurrentArgNumber+1
      NextArgument=`printf "%s" "$ArgList" | head -n $CurrentArgNumber | tail -n 1`
      NextArgumentOriginalArgumentNumber=`echo "$OriginalArgumentNumberList" | head -n $CurrentArgNumber | tail -n 1`
   fi
   NextArgumentFullPath=`ShowFullFilePath $PathOption "$NextArgument"`
   if [ "z$ErrorText" = zinteger ] ; then
      NextArgumentOriginal="$NextArgument"
      if [ -z "$NextArgument" ] ; then
         ShowUsage $ExitCode "ERROR: Argument passed $DirectionText $CurrentArgument is not an integer: \"$NextArgumentOriginal\"" >&2
      # Else if argument contains something other than a hyphen or digits
      elif [ "`printf "%s" "$NextArgument" | tr -d "[:digit:]-"`" ] ; then
         ShowUsage $ExitCode "ERROR: Argument passed $DirectionText $CurrentArgument is not an integer:
       \"$NextArgumentOriginal\"" >&2
      # Else if argument contains a hyphen that is not at the beginning
      elif [ "`printf "%s" "$NextArgument" | grep '..*-'`" ] ; then
         ShowUsage $ExitCode "ERROR: Argument passed $DirectionText $CurrentArgument is not an integer:
       \"$NextArgumentOriginal\"" >&2
      fi
      NextArgument=`expr "$NextArgument" / 1 2>/dev/null`
      test "$NextArgumentOriginal" -eq "$NextArgument" 2>/dev/null
      if [ $? != 0 ] ; then
         ShowUsage $ExitCode "ERROR: Value passed $DirectionText $CurrentArgument is out of range for this OS:
       $NextArgumentOriginal" >&2
      fi
      # If minimum value was specified
      if [ "$Min" ] ; then
         [ $NextArgument -lt $Min ] && ShowUsage $ExitCode "ERROR: Value passed $DirectionText $CurrentArgument ($NextArgumentOriginal) is less than
       minimum value ($Min)." >&2
      fi
      # If maximum value was specified
      if [ "$Max" ] ; then
         [ $NextArgument -gt $Max ] && ShowUsage $ExitCode "ERROR: Value passed $DirectionText $CurrentArgument ($NextArgumentOriginal) is greater than
       maximum value ($Max)." >&2
      fi
   elif [ "z$ErrorText" = "zfile, folder, or link" ] ; then
      [ ! -e "$NextArgument" -a ! -L "$NextArgument" ] && ShowUsage $ExitCode "ERROR: Argument passed $DirectionText $CurrentArgument is not a $ErrorText:
       \"$NextArgument\"" >&2
   elif [ "z$ErrorText" = "zunbroken link" ] ; then
      if [ ! -L "$NextArgument" ] ; then
         ShowUsage $ExitCode "ERROR: Argument passed $DirectionText $CurrentArgument is not a link:
       \"$NextArgument\"" >&2
      # Else if link is broken
      elif [ ! -e "$NextArgument" ] ; then
         ShowUsage $ExitCode "ERROR: The target of the link passed $DirectionText $CurrentArgument does not exist:
       \"$NextArgument\"" >&2
      fi
   elif [ "$ErrorText" ] ; then
      [ ! $TestOperator "$NextArgument" ] && ShowUsage $ExitCode "ERROR: Argument passed $DirectionText $CurrentArgument is not a $ErrorText:
       \"$NextArgument\"" >&2
   fi
   if [ "$PathOption" ] ; then
      if [ -z "$NextArgumentFullPath" ] ; then
         if [ -L "$NextArgument" ] ; then
            ShowUsage $ExitCode "ERROR: The target of the link passed $DirectionText $CurrentArgument does not exist:
       \"$NextArgument\"" >&2
         else
            ExitScript $ExitCode "WARNING: ShowFullFilePath function could not resolve path for:
         \"$NextArgument\"" >&2
         fi
      fi
   fi
   return 0
}

RemoveItem()
{
   # Usage:     RemoveItem path
   # Summary:   Deletes path specified. If DoShowFilesInstalled = true,
   #            adds path to list of files that would be removed instead
   #            of deleting it.
   #
   local ItemToDelete="$1"
   # If item does not exist
   if [ ! -e "$ItemToDelete" -a ! -L "$ItemToDelete" ] ; then
      return # Skip it
   else
      if [ -L "$ItemToDelete" ] ; then
         FileType="symbolic link"
      elif [ -d "$ItemToDelete" ] ; then
         # If filename contains a period with at least one character on each side
         if [ "`basename "$ItemToDelete" | grep '.\..'`" ] ; then
            FileType="bundle"
         else
            FileType="directory"
         fi
      else
         FileType="file"
      fi
      if $DoShowFilesInstalled ; then
         ListOfFilesInstalled="$ListOfFilesInstalled
--------------------------------------------------------------------------------
\"$Product\" $FileType:
$ItemToDelete"
         return
      fi
      echo
      echo "--------------------------------------------------------------------------------"
      echo "Removing \"$Product\" $FileType:"
      echo "$ItemToDelete"
      # Clear immutable bit to remove any Finder lock
      chflags -R nouchg "$ItemToDelete" &>/dev/null
      # Delete the item
      rm -rf "$ItemToDelete" &>/dev/null
      if [ -e "$ItemToDelete" -o -L "$ItemToDelete" ] ; then
         echo
         echo "ERROR: Failed to delete that $FileType."
         (( ++DeletionErrors ))
      else
         (( ++NumberOfItemsRemoved ))
      fi
   fi
}

ShowFullFilePath()
{
   # Usage:     ShowFullFilePath [-a] [-P | -L] [-e] Path [[-e] Path]
   # Version:   1.0.2
   # Summary:   Prints the full path starting at / of Path if Path exists
   #            and Path is accessible by the user calling this function.
   #            Run this function as root to ensure full path displaying.
   #            If there is more than one existing file that matches the
   #            name, then only the first path that the shell matches is
   #            printed unless -a or more than one path is specified.
   #            You can specify wild card characters ? and * and other
   #            argument operators in the Path (e.g., "../*", "a?.txt",
   #            "[ab]*").
   # Options:   -a   Show all matching paths, sorted alphanumerically. If
   #                 -P is not passed, the same file may be shown multiple
   #                 times if there is more than one matching link that
   #                 points to it.
   #            -e <Path>
   #                 Treat argument after -e as a path. Use -e to treat
   #                 -a, -e, -L, or -P as a path.
   #            -L   Show logical path, even if a file pointed to by a link
   #                 doesn't exist. This is the default.
   #            -P   Show physical path. If a link points to a file that
   #                 does not exist, the path won't be shown.
   # History: 1.0.1 - Added -e option and ability to pass multiple paths.
   #                  Arguments can now be passed in any order.
   #                  Fixed error that could occur when resolving links
   #                  with long paths.
   #          1.0.2 - Modified for case-sensitive volume compatibility.
   #                  Made temporary file names more distinctive.
   #
   local SFFPArgCount=$#
   local SFFPCurrentDir
   local SFFPCurrentDirTranslated
   local SFFPEachLine
   local SFFPEachPath
   local SFFPFile
   local SFFPLDir
   local SFFPLLinkLS
   local SFFPLLinkPath
   local SFFPLPath
   local SFFPPathOption=-L
   local SFFPSaveIFS="$IFS"
   local SFFPShowAll=false
   local SFFPTempBase=/private/tmp/ShowFullFilePath-`/usr/bin/basename "$0"`-`/bin/date +"%Y%m%d%H%M%S"`
   local SFFPTempFile="$SFFPTempBase.tmp"
   local SFFPTempFile2="$SFFPTempBase-2.tmp"
   /bin/rm -f "$SFFPTempFile" 2>/dev/null
   while [ $SFFPArgCount != 0 ] ; do
      case "$1" in
         -a)
            SFFPShowAll=true
            ;;
         -L|-P)
            SFFPPathOption="$1"
            ;;
         *)
            [ "z$1" = z-e ] && shift
            if [ "$1" ] ; then
               [ -s "$SFFPTempFile" ] && SFFPShowAll=true
               /usr/bin/printf "%s\n" "$1" >>"$SFFPTempFile"
            fi
            ;;
      esac
      shift
      let SFFPArgCount=$SFFPArgCount-1
   done
   [ ! -s "$SFFPTempFile" ] && return
   SFFPCurrentDir=`/bin/pwd`
   SFFPCurrentDirTranslated=`/bin/pwd $SFFPPathOption 2>/dev/null`
   if [ ! -d "$SFFPCurrentDirTranslated" ] ; then
      /bin/rm -f "$SFFPTempFile" 2>/dev/null
      return
   fi
   cd "$SFFPCurrentDirTranslated" 2>/dev/null
   if [ $? != 0 ] ; then
      /bin/rm -f "$SFFPTempFile" 2>/dev/null
      return
   fi
   /usr/bin/printf "" >"$SFFPTempFile2"
   IFS='
'
   for SFFPEachLine in `/bin/cat "$SFFPTempFile" 2>/dev/null` ; do
      cd "$SFFPCurrentDirTranslated" 2>/dev/null
      [ $? != 0 ] && break
      if [ "z$SFFPPathOption" = z-P ] ; then
         SFFPLPath="$SFFPEachLine"
         while [ -L "$SFFPLPath" ] ; do
            [ ! -e "$SFFPLPath" ] && break
            cd "`/usr/bin/dirname "$SFFPLPath" 2>/dev/null`" 2>/dev/null
            [ $? != 0 ] && break
            SFFPLDir=`/bin/pwd -P 2>/dev/null`
            [ ! -d "$SFFPLDir" ] && break
            SFFPLLinkLS=`/bin/ls -ld "$SFFPLPath" 2>/dev/null`
            [ -z "$SFFPLLinkLS" ] && break
            # If link or link target contains " -> " in its name
            if [ "`echo "z$SFFPLLinkLS" | grep ' -> .* -> '`" ] ; then
               SFFPLLinkPath=`/usr/bin/printf "%s" "$SFFPLLinkLS" | /usr/bin/awk -v THESTR="$SFFPLPath -> " '{ match($0,THESTR) ; print substr($0,RSTART+RLENGTH)}'`
            else
               SFFPLLinkPath=`echo "$SFFPLLinkLS" | awk -F " -> " '{print $2}'`
            fi
            # If link target begins with /
            if [ "`/usr/bin/printf "%s" "$SFFPLLinkPath" | grep '^/'`" ] ; then
               SFFPLPath="$SFFPLLinkPath"
            else
               SFFPLPath="$SFFPLDir/$SFFPLLinkPath"
            fi
            [ "`/usr/bin/printf "%s" "$SFFPLPath" | grep '^//'`" ] && SFFPLPath=`echo "$SFFPLPath" | /usr/bin/awk '{print substr($0,2)}'`
         done
         cd "$SFFPCurrentDirTranslated" 2>/dev/null
         [ $? != 0 ] && break
         if [ ! -e "$SFFPLPath" ] ; then
            $SFFPShowAll && continue || break
         fi
         SFFPEachPath="$SFFPLPath"
      else
         SFFPEachPath="$SFFPEachLine"
      fi
      if [ -d "$SFFPEachPath" ] ; then
         cd "$SFFPEachPath" 2>/dev/null
         if [ $? != 0 ] ; then
            $SFFPShowAll && continue || break
         fi
         SFFPFile=""
      elif [ -d "`/usr/bin/dirname "$SFFPEachPath" 2>/dev/null`" ] ; then
         cd "`/usr/bin/dirname "$SFFPEachPath" 2>/dev/null`" 2>/dev/null
         if [ $? != 0 ] ; then
            $SFFPShowAll && continue || break
         fi
         SFFPFile=`basename "$SFFPEachPath" 2>/dev/null`
         [ "z$SFFPFile" = z/ -o "z$SFFPFile" = z. -o "z$SFFPFile" = z.. ] && SFFPFile=""
      elif $SFFPShowAll ; then
         continue
      else
         break
      fi
      SFFPDir=`/bin/pwd $SFFPPathOption 2>/dev/null`
      if [ ! -d "$SFFPDir" ] ; then
         $SFFPShowAll && continue || break
      fi
      SFFPPath="$SFFPDir`[ "z$SFFPFile" != z -a "z$SFFPDir" != z/ -a "z$SFFPDir" != z// ] && echo /`$SFFPFile"
      if [ ! -e "$SFFPPath" -a ! -L "$SFFPPath" ] ; then
         $SFFPShowAll && continue || break
      fi
      [ "`echo "$SFFPPath" | grep '^//'`" ] && SFFPPath=`echo "$SFFPPath" | /usr/bin/awk '{print substr($0,2)}'`
      echo "$SFFPPath" >>"$SFFPTempFile2"
      # If neither option -a nor more than one path was passed, don't show any more names
      ! $SFFPShowAll && break
   done
   IFS=$SFFPSaveIFS
   [ -s "$SFFPTempFile2" ] && /usr/bin/sort -f "$SFFPTempFile2" | /usr/bin/uniq
   /bin/rm -f "$SFFPTempFile" "$SFFPTempFile2" 2>/dev/null
   cd "$SFFPCurrentDir" 2>/dev/null
}

ShowHelp()
{
   # Usage:     ShowHelp [$1]
   # Argument:  $1 = Exit code.
   # Summary:   Displays script usage and help then exits script.
   #            If a number is passed to $1, then script exits with
   #            that number; else, script is not exited.
   #
   echo "
Usage:   $FullScriptName [-cfHhLlV]

Summary: Removes security software products that are not compatible with
         NortonLifeLock products. If files are found to delete, a list of
         those files is shown and a confirmation prompt appears before
         removals begin.

Options:
   -c    Do not clear screen.
   -f    Force uninstall without confirmation prompt.
   -H    Show program usage.
   -h    Show program help.
   -L    List all files that this program will attempt to find and delete.
         No files are removed when using this option.
   -l    List files that are currently installed that this program will attempt
         to delete. No files are removed when using this option.
   -V    Show program version.
"
   [ "$1" ] && exit $1
}

ShowUsage()
{
   # Usage:     ShowUsage [$1 [$2]]
   # Arguments: $1 = Exit code.
   #            $2 = Error message to display before showing usage.
   # Summary:   Displays script usage. If an exit code is passed,
   #            script is exited with that value.
   #
   if [ "$2" ] ; then
      echo
      echo "$2"
      echo
   fi
   ShowHelp | grep "^Usage.*:"
   [ "$2" ] && echo
   [ -n "$1" ] && exit "$1"
}

YorN()
{
   # Usage:     YorN [-e] [-n] [-q] [Default] String
   # Version:   1.0.3
   # Arguments: -e - Use echochar program to get input. ScriptDir must be
   #                 defined, echochar must be executable, and ScriptDir
   #                 must be within or next to LiveUpdateTools folder.
   #                 Note that keyboard must be used for echochar input,
   #                 so piped standard input and ctrl-C are not usable.
   #                 The echochar program was written by Bill Allen.
   #            -n - Don't print a blank line after entry.
   #            -q - Add q for quit option.
   #            Default - n, false, y, true. If not one of those, no
   #                      default is used.
   #            String - The question to ask, without a question mark.
   # Summary:   Prompts with String + "? (y/n) " + "[n] " or "[y] " or "",
   #            depending on Default passed. Prompt is repeated until y or
   #            n is entered, or until "" is entered if Default is n or y.
   #            A blank line is printed after y or n is entered unless -n
   #            is specified.
   #            Returns 0 if y is entered, 1 if n is entered, 2 if q is
   #            entered and -q was passed to YorN.
   # History:   1.0.0 - Added Intel-only version of echochar for OS 10.5
   #                    and later; prior OS versions use old PPC version.
   #            1.0.1 - Added arch check so that PPC version is used on PPC.
   #            1.0.2 - Changed carriage return value to "`printf "\r"`".
   #            1.0.3 - Added macOS 11+ support.
   #
   local YNAdditionalText=""
   local YNArgCount=$#
   local YNDefaultAnswer=""
   local YNDefaultAnswerString=""
   local YNDoPrintBlank=true
   local YNechochar=""
   local YNmacOSVersion
   local YNmacOSVersionMinor
   local YNResponse=""
   local YNTextToShow=""
   while [ $YNArgCount -gt 0 ] ; do
      if [ "z$1" = z-e ] ; then
         YNechochar="$ScriptDir/LiveUpdateTools/CharTools/echochar"
         [ ! -x "$YNechochar" ] && YNechochar="$ScriptDir/CharTools/echochar"
         [ ! -x "$YNechochar" ] && YNechochar="$ScriptDir/../CharTools/echochar"
         [ ! -x "$YNechochar" ] && YNechochar="$ScriptDir/../../CharTools/echochar"
         [ ! -x "$YNechochar" ] && YNechochar="$ScriptDir/../../../CharTools/echochar"
         [ ! -x "$YNechochar" ] && YNechochar="$ScriptDir/../../../../CharTools/echochar"
         [ ! -x "$YNechochar" ] && YNechochar="$ScriptDir/../../../../../CharTools/echochar"
         if [ -n "`arch 2>/dev/null | grep -i ppc`" ] ; then
            YNechochar="$YNechochar"-ppc
         else
            YNmacOSVersion=`cat /System/Library/CoreServices/SystemVersion.plist 2>/dev/null | tr '\015' '\012' | grep . | grep -A1 '<key>ProductVersion<' | tail -n 1 | awk -F '<string>' '{print $2}' | awk -F '<' '{print $1}'`
            # If OS 10.x
            if [ "z`printf "%s" "$YNmacOSVersion" | awk -F . '{print $1}'`" = z10 ] ; then
               YNmacOSVersionMinor=`echo "$YNmacOSVersion" | awk -F . '{print $2}'`
               if [ -n "$YNmacOSVersionMinor" ] ; then
                  # If OS is less than 10.15
                  if [ $YNmacOSVersionMinor -lt 5 ] ; then
                     YNechochar="$YNechochar"-ppc
                  fi
               fi
            fi
         fi
      elif [ "z$1" = z-n ] ; then
         YNDoPrintBlank=false
      elif [ "z$1" = z-q ] ; then
         YNAdditionalText=/q
      elif [ "z$1" = zn -o "z$1" = zfalse ] ; then
         YNDefaultAnswer=n
         YNDefaultAnswerString="[n] "
      elif [ "z$1" = zy -o "z$1" = ztrue ] ; then
         YNDefaultAnswer=y
         YNDefaultAnswerString="[y] "
      else
         YNTextToShow="$1"
      fi
      shift
      let YNArgCount=$YNArgCount-1
   done
   [ "$2" ] && YNTextToShow="$2"
   while [ : ] ; do
      printf "%s? (y/n$YNAdditionalText) %s" "$YNTextToShow" "$YNDefaultAnswerString"
      if [ -x "$YNechochar" ] ; then
         YNResponse=`"$YNechochar"`
         echo "$YNResponse"
         # If response was a carriage return, make it NULL
         [ "$YNResponse" = "`printf "\r"`" ] && YNResponse=""
      else
         read YNResponse
      fi
      if [ "$YNResponse" ] ; then
         YNResponse=`printf "%s" "$YNResponse" | awk '{print tolower($0)}'`
      else
         YNResponse="$YNDefaultAnswer"
      fi
      if [ "z$YNResponse" = zn ] ; then
         $YNDoPrintBlank && echo
         return 1
      elif [ "z$YNResponse" = zq -a -n "$YNAdditionalText" ] ; then
         $YNDoPrintBlank && echo
         return 2
      elif [ "z$YNResponse" = zy ] ; then
         $YNDoPrintBlank && echo
         return 0
      fi
   done
}

# *** Beginning of Commands to Execute ***

ScriptPath=`ShowFullFilePath "$0" -P`
[ ! -e "$ScriptPath" ] && ExitScript 99 "WARNING: ScriptPath definition failed. `basename "$0"` aborted."
FullScriptName=`basename "$ScriptPath"`
ScriptDir=`dirname "$ScriptPath"`
if [ $# -eq 0 ] ; then   # If no arguments were passed to script
   # Run script as if it was double-clicked in Finder so that
   # screen will be cleared and quit message will be displayed.
   RunScriptAsStandAlone=true
else
   # Run script in command line mode so that
   # screen won't be cleared and quit message won't be displayed.
   RunScriptAsStandAlone=false
fi
$RunScriptAsStandAlone && clear
ProcessArguments "$@"
if $DoShowSearchList ; then
   echo
   echo "$FullScriptName would look for and delete the following:"
   echo "$ProductFileList"
   ExitScript 0
elif [ "`whoami`" != root ] ; then
   if $PublicVersion ; then
      GetAdminPassword true   #    Prompt user for admin password
   fi
   # Run this script again as root
   sudo -p "Please enter your admin password: " "$0" "$@"
   ErrorFromSudoCommand=$?
   # If unable to authenticate
   if [ $ErrorFromSudoCommand -eq 1 ] ; then
      echo "You entered an invalid password or you are not an admin user. Program aborted."
      ExitScript 1
   fi
   if $PublicVersion ; then
      sudo -k   # Make sudo require a password the next time it is run
   fi
   exit $ErrorFromSudoCommand #    Exit so script doesn't run again
fi
echo
IFS=$'\n' # Set IFS to newlines
if $DoShowFilesInstalled ; then
   echo "Searching for files that would be removed - nothing will be removed."
else
   echo "Searching for files to remove."
   DoShowFilesInstalled=true
   ListOfFilesInstalled=""
   for Line in $ProductFileList ; do
      # If it's a file path (begins with /)
      if [ "`printf "%s" "$Line" | grep '^/'`" ] ; then
         RemoveItem "$Line"
      else
         Product="$Line"
      fi
   done
   if [ -z "$ListOfFilesInstalled" ] ; then
      ExitScript 0 "There were no files found to remove."
   else
      echo
      echo "The following competitive product files are currently installed:"
      echo "$ListOfFilesInstalled"
      echo
      if ! $DoForceUninstall ; then
         if ! YorN n "Are you sure you want to remove the above items" ; then
            ExitScript -b 0 "No files were removed."
         fi
      fi
      echo "Will now remove those items."
   fi
   DoShowFilesInstalled=false
fi
DeletionErrors=0
ListOfFilesInstalled=""
NumberOfItemsRemoved=0
for Line in $ProductFileList ; do
   # If it's a file path (begins with /)
   if [ "`printf "%s" "$Line" | grep '^/'`" ] ; then
      RemoveItem "$Line"
   else
      Product="$Line"
   fi
done
echo
if [ -n "$ListOfFilesInstalled" ] ; then
   echo "These items are installed and would be deleted by this program:"
   echo "$ListOfFilesInstalled"
elif $DoShowFilesInstalled ; then
   echo "There were no files found that would be removed."
elif [ $DeletionErrors = 1 ] ; then
   ExitScript -b 3 "WARNING: A deletion failed. Look for \"ERROR:\" above."
elif [ $DeletionErrors -gt 0 ] ; then
   ExitScript -b 3 "WARNING: $DeletionErrors deletions failed. Look for \"ERROR:\" above."
elif [ $NumberOfItemsRemoved = 1 ] ; then
   ExitScript -b 0 "ATTENTION: An item was removed. You should restart the computer."
else
   ExitScript -b 0 "ATTENTION: There were $NumberOfItemsRemoved items removed. You should restart the computer."
fi
echo
ExitScript 0

# *** End of Commands to Execute ***
